diff --git a/Units/parser-ada.r/ada-overriding.d/args.ctags b/Units/parser-ada.r/ada-overriding.d/args.ctags
new file mode 100644
index 0000000000..5ee5f79f70
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/args.ctags
@@ -0,0 +1 @@
+--sort=no
diff --git a/Units/parser-ada.r/ada-overriding.d/expected.tags b/Units/parser-ada.r/ada-overriding.d/expected.tags
new file mode 100644
index 0000000000..733e77d8d0
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/expected.tags
@@ -0,0 +1,13 @@
+Input	input.ads	/^package Input$/;"	P
+Tasche_T	input.ads	/^   task type Tasche_T is new Carte_T with$/;"	K	packspec:Input
+Inutile	input.ads	/^   procedure Inutile$/;"	R	packspec:Input
+input_2	input_2.adb	/^package body input_2$/;"	p
+Tasche_T	input_2.adb	/^   task body Tasche_T is$/;"	k	package:input_2	file:
+Coucou	input_2.adb	/^      accept Coucou do$/;"	e	task:Tasche_T	file:
+Inutile	input_2.adb	/^   procedure Inutile$/;"	r	package:input_2	file:
+Input_3	input_3.ads	/^package Input_3 is$/;"	P
+Object	input_3.ads	/^    type Object is tagged null record;$/;"	t	packspec:Input_3
+Primitive	input_3.ads	/^   function  Primitive return access Object; -- new in Ada 2005$/;"	R	packspec:Input_3
+Derived_Object	input_3.ads	/^   type Derived_Object is new Object with null record;$/;"	t	packspec:Input_3
+Primitive	input_3.ads	/^   procedure Primitive (This : in Derived_Object); -- new primitive operation$/;"	R	packspec:Input_3
+Primitive	input_3.ads	/^   function  Primitive return access Derived_Object;$/;"	R	packspec:Input_3
diff --git a/Units/parser-ada.r/ada-overriding.d/input.ads b/Units/parser-ada.r/ada-overriding.d/input.ads
new file mode 100644
index 0000000000..44d42341f3
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/input.ads
@@ -0,0 +1,42 @@
+--  Taken from #2382 submitted by @JulienPivard
+--  @summary
+--  Implémentation par une tâche.
+--  @description
+--  Implémentation par une tache de la classe synchronisé.
+--  @group Version tâche
+--
+--  package Carte_P.Tasche_P
+package Input
+   with
+      Pure           => False,
+      Preelaborate   => False,
+      Elaborate_Body => True,
+      Spark_Mode     => Off
+is
+
+   ---------------------------------------------------------------------------
+   task type Tasche_T is new Carte_T with
+   --  Implémentation par une tâche de l'interface Carte_T.
+
+      -----------------------------------
+      overriding
+      entry Coucou;
+      --  Implémentation par un accept.
+
+      -----------------------------------
+      --  overriding
+      --  entry Inutile;
+      --  Implémentation par un accept.
+      --  @param This
+      --  La carte.
+   end Tasche_T;
+   ---------------------------------------------------------------------------
+
+   overriding
+   procedure Inutile
+      (This : in out Tasche_T);
+   --  Implémentation par une procédure.
+   --  @param This
+   --  La carte.
+
+end Carte_P.Tasche_P;
diff --git a/Units/parser-ada.r/ada-overriding.d/input_2.adb b/Units/parser-ada.r/ada-overriding.d/input_2.adb
new file mode 100644
index 0000000000..f687ac8ef7
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/input_2.adb
@@ -0,0 +1,36 @@
+--  Taken from #2382 submitted by @JulienPivard
+with Ada.Text_IO;
+
+package body input_2
+   with Spark_Mode => Off
+is
+
+   ---------------------------------------------------------------------------
+   task body Tasche_T is
+      --  Les déclarations qui vont bien.
+   begin
+      accept Coucou do
+         null;
+      end Coucou;
+
+      Ada.Text_IO.Put_Line (Item => "Wesh gros je suis une tâche");
+
+      --  accept Inutile do
+      --     null;
+      --  end Inutile;
+      abort Tasche_T;
+   end Tasche_T;
+   ---------------------------------------------------------------------------
+
+   ---------------------------------------------------------------------------
+   overriding
+   procedure Inutile
+      (This : in out Tasche_T)
+   is
+   begin
+      null;
+   end Inutile;
+   ---------------------------------------------------------------------------
+
+end input_2;
+
diff --git a/Units/parser-ada.r/ada-overriding.d/input_3.ads b/Units/parser-ada.r/ada-overriding.d/input_3.ads
new file mode 100644
index 0000000000..f30a4ceffa
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/input_3.ads
@@ -0,0 +1,14 @@
+--  Taken from https://en.wikibooks.org/wiki/Ada_Programming/Object_Orientation#Overriding_indicators
+package Input_3 is
+    type Object is tagged null record;
+
+   function  Primitive return access Object; -- new in Ada 2005
+
+   type Derived_Object is new Object with null record;
+
+   not overriding -- new optional keywords in Ada 2005
+   procedure Primitive (This : in Derived_Object); -- new primitive operation
+
+   overriding
+   function  Primitive return access Derived_Object;
+end X;
diff --git a/parsers/ada.c b/parsers/ada.c
index bbd6792af8..c76ea436d4 100644
--- a/parsers/ada.c
+++ b/parsers/ada.c
@@ -227,7 +227,9 @@ typedef enum eAdaKeywords
   ADA_KEYWORD_IS,
   ADA_KEYWORD_LOOP,
   ADA_KEYWORD_NEW,
+  ADA_KEYWORD_NOT,
   ADA_KEYWORD_OR,
+  ADA_KEYWORD_OVERRIDING,		/* Ada 2005 */
   ADA_KEYWORD_PACKAGE,
   ADA_KEYWORD_PRAGMA,
   ADA_KEYWORD_PRIVATE,
@@ -270,7 +272,9 @@ static const char *AdaKeywords[] =
   "is",
   "loop",
   "new",
+  "not",
   "or",
+  "overriding",
   "package",
   "pragma",
   "private",
@@ -1515,6 +1519,12 @@ static adaTokenInfo *adaParse(adaParseMode mode, adaTokenInfo *parent)
             skipPast(";");
           }
         } /* else if(adaKeywordCmp(ADA_KEYWORD_SEPARATE)) */
+		else if (adaKeywordCmp(ADA_KEYWORD_OVERRIDING)
+				 || adaKeywordCmp (ADA_KEYWORD_NOT))
+		{
+			/* Do nothing, just ignore these keywords. */
+			;
+		}
         else
         {
           /* otherwise, nothing was found so just skip until the end of this
@@ -1723,6 +1733,12 @@ static adaTokenInfo *adaParse(adaParseMode mode, adaTokenInfo *parent)
 
           skipWhiteSpace();
         }
+		else if (adaKeywordCmp(ADA_KEYWORD_OVERRIDING)
+				 || adaKeywordCmp (ADA_KEYWORD_NOT))
+		{
+			/* Do nothing, just ignore these keywords. */
+			;
+		}
         else
         {
           /* if nothing else matched this is probably a variable, constant
